# git-ignore [![Build Status](https://travis-ci.com/sondr3/git-ignore.svg?token=jVZ9BLfdPx6kBm4z8gXS&branch=master)](https://travis-ci.com/sondr3/git-ignore) [![Crates.io](https://img.shields.io/crates/v/git-ignore-generator.svg)](https://crates.io/crates/git-ignore-generator)

## What and why

Far too often I find myself going to [gitignore.io](https://www.gitignore.io/) to quickly get
`.gitignore` templates for my projects, so what would any reasonable programmer
do for menial and repetitive tasks? [Automate](https://xkcd.com/1319/) [it](https://xkcd.com/1205/)! Now you can quickly
and easily get and list all the templates available on gitignore.io.

# Installation

Make sure you have Rust installed (I recommend installing via
[rustup](https://rustup.rs/)), then run `cargo install git-ignore-generator`.

To list all the available templates:

```sh
$ git ignore --list
[
    "1c",
    "1c-bitrix",
    "a-frame",
    "actionscript",
    "ada",
    [...],
    "zukencr8000"
]
```

You can also search for templates (`--list` can be both before and after the
queries):

```sh
$ git ignore rust intellij --list
[
    "intellij",
    "intellij+all",
    "intellij+iml",
    "rust"
]
```

Then you can download the templates by omitting `--list`:

```sh
$ git ignore rust intellij+all

# Created by https://www.gitignore.io/api/rust,intellij+all
# Edit at https://www.gitignore.io/?templates=rust,intellij+all

[...]

# These are backup files generated by rustfmt
**/*.rs.bk

# End of https://www.gitignore.io/api/rust,intellij+all
```

Finally, if need be, you can always run `git ignore -h` to see more options ---
spoiler alert, there are none.
